CS::PluginCommon::ShaderProgramPluginGL::ClipPlanes Class Reference (Crystal Space 2.0 Public API Reference)

| ## Public API Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions
CS::PluginCommon::ShaderProgramPluginGL::ClipPlanes Class Reference

Helper class for user defined OpenGL clip planes. More...

`#include <csplugincommon/opengl/shaderplugin.h>`

List of all members.

## Public Types
enum | ClipSpace { Object, World, Eye }
| Possible clip plane spaces. More...
## Public Member Functions
void | DisableClipPlanes ()
| Disable all clip planes previously enabled.
bool | EnableClipPlane (size_t n)
| Enable the n th OpenGL clip plane without setting it.
bool | EnableNextClipPlane ()
| Enable the next available OpenGL clip plane without setting it.
void | Initialize (iObjectRegistry *objectReg)
| Initialize, should be called by plugin Initialize().
void | SetShaderVars (const csShaderVariableStack &stack)
| Set shader vars required for transforming clip planes.
bool | AddClipPlane (const csPlane3 &plane, ClipSpace space)
| Add a clip plane.
bool | AddClipPlane (const csVector4 &plane, ClipSpace space)
| Add a clip plane.

## Detailed Description

Helper class for user defined OpenGL clip planes.

Definition at line 116 of file shaderplugin.h.

## Member Enumeration Documentation

enum CS::PluginCommon::ShaderProgramPluginGL::ClipPlanes::ClipSpace

Possible clip plane spaces.

Enumerator:

  Object | Object space.
  World | World space.
  Eye | Eye space (pre-projection camera space)

Definition at line 138 of file shaderplugin.h.

## Member Function Documentation

bool CS::PluginCommon::ShaderProgramPluginGL::ClipPlanes::AddClipPlane | ( | const csPlane3 & | plane,
|  | ClipSpace | space
| ) |  |

Add a clip plane.

bool CS::PluginCommon::ShaderProgramPluginGL::ClipPlanes::AddClipPlane | ( | const csVector4 & | plane,
|  | ClipSpace | space
| ) |  | `[inline]`

Add a clip plane.

Definition at line 150 of file shaderplugin.h.

void CS::PluginCommon::ShaderProgramPluginGL::ClipPlanes::DisableClipPlanes | ( |  | ) |

Disable all clip planes previously enabled.

bool CS::PluginCommon::ShaderProgramPluginGL::ClipPlanes::EnableClipPlane | ( | size_t | n | ) |

Enable the n th OpenGL clip plane without setting it.

It is up to the caller to call glClipPlane().

bool CS::PluginCommon::ShaderProgramPluginGL::ClipPlanes::EnableNextClipPlane | ( |  | ) |

Enable the next available OpenGL clip plane without setting it.

It is up to the caller to call glClipPlane().

void CS::PluginCommon::ShaderProgramPluginGL::ClipPlanes::Initialize | ( | iObjectRegistry * | objectReg | ) |

Initialize, should be called by plugin Initialize().

void CS::PluginCommon::ShaderProgramPluginGL::ClipPlanes::SetShaderVars | ( | const csShaderVariableStack & | stack | ) |

Set shader vars required for transforming clip planes.

The documentation for this class was generated from the following file:

- csplugincommon/opengl/shaderplugin.h